
/* Group.H */

#ifndef GROUP_H
#define GROUP_H

#include "object.h"
#include "list.h"

/* Constants */

#define DEFAULT_GROUP  "NoGroup"
#define REGISTER_GROUP "Register"

/* Types */

typedef struct {
   int   Type;
   char *Id;
   char  Leader[ID_SIZE+1];
   int   Level;
   char *Name;
} group;

/* Variables */

extern list GroupList[1];

/* Prototypes */

extern group *NewGroup    (const char *Id, const char *Leader, int Level, const char *Name);
extern void   DeleteGroup (group *Group);
extern group *SearchGroup (const char *Id);
extern int    GroupLevel  (const group *Group);

#endif /* ! defined GROUP_H */

/* End of Group.H */

