
/* Token.H */

#ifndef TOKEN_H
#define TOKEN_H

#include "object.h"

/* Constants */

/*
enum { TK_NUMBER, TK_ID, TK_FILE, TK_WORD, TK_STRING };
*/

#define PASSWORD_SIZE 8

/* Types */

typedef struct {
   int     Type;
   char   *String;
   object *Object;
   int     Value;
} arg;

/* Prototypes */

extern int   IsNumber      (const char *String);
extern int   IsId          (const char *String);
extern int   IsPassword    (const char *String);
extern int   IsFile        (const char *String);
extern int   IsWord        (const char *String);
extern int   IsString      (const char *String);

extern int   IsEmptyString (const char *String);
extern int   SameChar      (char Char1, char Char2);
extern int   SameString    (const char *String1, const char *String2);
extern int   StartWith     (const char *String1, const char *String2);
extern int   Contain       (const char *String1, const char *String2);

extern char *ToLower       (const char *String);

#endif /* ! defined TOKEN_H */

/* End of Token.H */

